#include <windows.h>
#include <winternl.h>
#include <ntstatus.h>
#include <ntddscsi.h>
#include <shlwapi.h>
#include <shlobj.h>
#include <dbt.h>
#include <stdio.h>
#include <conio.h>
#include <errno.h>
#include <intrin.h>
#include "whirlpool\whirlpool.h"
#include "keccak\keccak.h"
#include "xts\xts.h"
#include "scrypt\scrypt.h"
#include "misc\misc.h"
#include "inc\imdproxy.h"
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wunknown-pragmas"
#include "inc\common.h"
#pragma GCC diagnostic pop

#define DEF_BUFFER_SIZE (1 << 20)
#define AIM_BUFFER_SIZE (2 << 20)

static unsigned int buffer_size = DEF_BUFFER_SIZE;
static __int64 global_offset = 0;
static int sector_size = 512;
static TCHAR comm_device[20];
static ULONG aim_device = IMSCSI_AUTO_DEVICE_NUMBER;
static IMDPROXY_INFO_RESP proxy_info = {};
static TCHAR file_name[32768 + 200];
static TCHAR *mount_point = NULL;
static DWORD timeout = INFINITE;
static TCHAR *format_param = L"";
static TCHAR *run_command = NULL;
static PROCESS_INFORMATION pi_mount;
static int verbose = 1;
static char global_str[80];
static TCHAR *password;
static unsigned int pass_size;
static struct {unsigned char whirlpool[6][32], keccak[6][32];} thread_header_key;
static unsigned char salt_whirlpool[64 + 4], salt_keccak[64 + 4];
static BYTE detach_console = FALSE;
static unsigned long enc_cipher = 0, dec_cipher = 0;
static SYSTEM_INFO sys;
static HANDLE encrypt_event[64], decrypt_event[64], crypt_done[64];
static void *volatile thread_buffer;
static volatile unsigned int request_size;
static volatile __int64 thread_offset;
static OVERLAPPED overlap_read, overlap_write = {};
static unsigned char *write_buf;
static unsigned int expected_write = 0;
static BYTE suspend_close = FALSE, force_aim = FALSE, use_imdisk;
static HANDLE h, h_aimapi, exit_event, clean_ok;
static HWND console_hwnd;
static FARPROC ImDiskOpenDeviceByMountPoint, ImDiskForceRemoveDevice, ImDiskRemoveMountPoint;
static DWORD last_err = 0;

static char *cipher_name[] = {"", "AES", "Serpent", "Twofish"};

#pragma pack(push, 1)
typedef struct {
	unsigned char salt[64]; short version;
	unsigned char hash[WHIRLPOOL_DIGESTSIZE]; unsigned char master_key[6][32];
	__int64 volume_offset; __int64 volume_size;
} HEADER_STRUCT;
#pragma pack(pop)

static void out(char *format, ...);
static void critical_err(char *format, ...);
static void disp_err(char *txt);
static DWORD __stdcall thread_command(LPVOID lpParam);
static DWORD __stdcall aim_mount(LPVOID lpParam);
static DWORD __stdcall aim_dismount(LPVOID lpParam);


/*void disp(void *buf, int size)
{
	int i;
	for (i = 0; i < size; i++) out("%02X", ((unsigned char*)buf)[i]);
	out("\n");
}*/


static DWORD __stdcall encrypt_thread(LPVOID lpParam)
{
	unsigned int i, i_start = (size_t)lpParam << 9, i_inc = sys.dwNumberOfProcessors << 9;

	for (;;) {
		WaitForSingleObject(encrypt_event[(int)(size_t)lpParam], INFINITE);
		for (i = i_start; i < request_size; i += i_inc)
			XTS_EncryptSector(enc_cipher, (thread_offset + i) >> 9, thread_buffer + i);
		SetEvent(crypt_done[(int)(size_t)lpParam]);
	}
	return 0;
}

static DWORD __stdcall decrypt_thread(LPVOID lpParam)
{
	unsigned int i, i_start = (size_t)lpParam << 9, i_inc = sys.dwNumberOfProcessors << 9;

	for (;;) {
		WaitForSingleObject(decrypt_event[(int)(size_t)lpParam], INFINITE);
		for (i = i_start; i < request_size; i += i_inc)
			XTS_DecryptSector(dec_cipher, (thread_offset + i) >> 9, thread_buffer + i);
		SetEvent(crypt_done[(int)(size_t)lpParam]);
	}
	return 0;
}


static int physical_read(void *buf, unsigned int size, __int64 offset)
{
	unsigned int i, current_size, next_size, size_done;
	DWORD bytes_read;
	__int64 *overlap_read_Offset = (__int64*)&overlap_read.Offset;

	*overlap_read_Offset = offset;
	next_size = min(size, 32768);
	ReadFile(h, buf, next_size, NULL, &overlap_read);
	size_done = 0;

	if (verbose >= 2) out(" ? Read: %u bytes at offset %I64d\n", size, offset);

	do {
		current_size = next_size;
		next_size = min(size - (size_done + current_size), 65536);

		thread_buffer = buf;
		request_size = current_size;
		thread_offset = offset;
		i = 0;

		GetOverlappedResult(h, &overlap_read, &bytes_read, TRUE);
		if (bytes_read != current_size) {
			critical_err("%%Read error: %u / %d bytes at offset %I64d.\n", (unsigned int)bytes_read, current_size, *overlap_read_Offset);
			return EIO;
		}
		if (next_size) {
			*overlap_read_Offset = offset + current_size;
			ReadFile(h, buf + current_size, next_size, NULL, &overlap_read);
		}
		do SetEvent(decrypt_event[i]); while (++i < sys.dwNumberOfProcessors);
		size_done += current_size;
		buf += current_size;
		offset += current_size;
		WaitForMultipleObjects(sys.dwNumberOfProcessors, crypt_done, TRUE, INFINITE);
	} while (next_size);

	return 0;
}

static int physical_write(void *buf, unsigned int size, __int64 offset)
{
	unsigned int i;
	int	err = 0;
	DWORD bytes_written;
	__int64 *overlap_write_Offset = (__int64*)&overlap_write.Offset;

	thread_buffer = buf;
	request_size = size;
	thread_offset = offset;
	i = 0; do SetEvent(encrypt_event[i]); while (++i < sys.dwNumberOfProcessors);
	WaitForMultipleObjects(sys.dwNumberOfProcessors, crypt_done, TRUE, INFINITE);

	GetOverlappedResult(h, &overlap_write, &bytes_written, TRUE);
	if (bytes_written != expected_write) {
		critical_err("%%Write error: %u / %u bytes at offset %I64d.\n", (unsigned int)bytes_written, expected_write, *overlap_write_Offset);
		err = EIO;
	}
	memcpy(write_buf, buf, size);
	*overlap_write_Offset = offset;
	WriteFile(h, write_buf, size, NULL, &overlap_write);
	expected_write = size;

	if (verbose >= 2) out(" ! Write: %u bytes at offset %I64d\n", size, offset);

	return err;
}


static int do_comm()
{
	HANDLE shm_request_event, shm_response_event;
	unsigned char *shm_view, *main_buf;
	IMDPROXY_READ_REQ *req_block;
	IMDPROXY_WRITE_RESP *resp_block;
	HANDLE hFileMap;
	ULARGE_INTEGER map_size;
	char objname[40], *index;
	STARTUPINFO si = {sizeof si};
	PROCESS_INFORMATION pi;
	DWORD wait_result;

	swprintf(comm_device, _countof(comm_device), L"%I64x", _rdtsc());
	index = objname + sprintf(objname, "Global\\%S", comm_device);

	map_size.QuadPart = buffer_size + IMDPROXY_HEADER_SIZE;

	if (!(hFileMap = CreateFileMappingA(INVALID_HANDLE_VALUE, NULL, PAGE_READWRITE | SEC_COMMIT, map_size.HighPart, map_size.LowPart, objname))) {
		disp_err("CreateFileMapping() failed.\nPlease check that you have administrative privileges.");
		return last_err;
	}
	if (!(shm_view = MapViewOfFile(hFileMap, FILE_MAP_WRITE, 0, 0, 0))) {
		disp_err("MapViewOfFile() failed.");
		return last_err;
	}

	lock_large_buf(shm_view, map_size.LowPart);

	main_buf = shm_view + IMDPROXY_HEADER_SIZE;
	req_block = (IMDPROXY_READ_REQ*)shm_view;
	resp_block = (IMDPROXY_WRITE_RESP*)shm_view;

	strcpy(index, "_Request");
	if (!(shm_request_event = CreateEventA(NULL, FALSE, FALSE, objname)) || GetLastError() == ERROR_ALREADY_EXISTS) {
		disp_err("CreateEvent() failed.");
		return last_err;
	}
	strcpy(index, "_Response");
	if (!(shm_response_event = CreateEventA(NULL, FALSE, FALSE, objname))) {
		disp_err("CreateEvent() failed.");
		return last_err;
	}

	if (use_imdisk) {
		if (wcslen(mount_point) > 32766) mount_point[32766] = 0;
		if (wcslen(format_param) > 100) format_param[100] = 0;
		swprintf(file_name, _countof(file_name), L"imdisk -a -t proxy -m \"%s\" -o shm -f %s -S %d%S%s%S", mount_point, comm_device, sector_size, format_param[0] ? " -p \"" : "", format_param, format_param[0] ? "\"" : "");
		CreateProcess(NULL, file_name, NULL, NULL, TRUE, verbose ? 0 : CREATE_NO_WINDOW, NULL, NULL, &si, &pi_mount);
	} else {
		pi_mount.hProcess = CreateEventA(NULL, FALSE, FALSE, NULL);
		CreateThread(NULL, 0, aim_mount, NULL, 0, NULL);
	}

	SetLastError(0);
	if (WaitForSingleObject(shm_request_event, 10000) != WAIT_OBJECT_0) {
		disp_err("WaitForSingleObject() failed.");
		return last_err;
	}
	if (req_block->request_code != IMDPROXY_REQ_INFO) {
		disp_err("Incorrect first request.");
		return 1;
	}

	out("Connection on object %S.\n", comm_device);
	CreateThread(NULL, 0, thread_command, NULL, 0, NULL);
	memcpy(shm_view, &proxy_info, sizeof proxy_info);

	for (;;) {
		if (!SetEvent(shm_response_event)) {
			critical_err("SetEvent() failed.");
			return last_err;
		}
		while ((wait_result = WaitForSingleObject(shm_request_event, timeout)) != WAIT_OBJECT_0) {
			if (wait_result == WAIT_TIMEOUT) {
				out("Inactivity period elapsed.\n");
				if (use_imdisk) {
					swprintf(file_name, _countof(file_name), L"imdisk -D -m \"%s\"", mount_point);
					CreateProcess(NULL, file_name, NULL, NULL, FALSE, CREATE_NO_WINDOW, NULL, NULL, &si, &pi);
				} else
					CreateThread(NULL, 0, aim_dismount, NULL, 0, NULL);
			} else {
				critical_err("WaitForSingleObject() failed.");
				return last_err;
			}
		}
		if (req_block->request_code == IMDPROXY_REQ_READ)
			resp_block->errorno = physical_read(main_buf, req_block->length, global_offset + req_block->offset);
		else if (req_block->request_code == IMDPROXY_REQ_WRITE) {
			if (req_block->offset >= proxy_info.file_size || req_block->offset + req_block->length > proxy_info.file_size) {
				critical_err("%%Error: invalid write request (volume offset=%I64d size=%I64u).\n", req_block->offset, req_block->length);
				resp_block->errorno = EINVAL;
			} else resp_block->errorno = physical_write(main_buf, req_block->length, global_offset + req_block->offset);
		} else {
			out("Connection closed.\n");
			SecureZeroMemory(main_buf, buffer_size);
			WaitForSingleObject(overlap_write.hEvent, INFINITE);
			SecureZeroMemory(write_buf, buffer_size);
			return 0;
		}
		resp_block->length = req_block->length;
	}
}

#pragma GCC optimize "Os"

static void out(char *format, ...)
{
	if (!verbose) return;
	va_list args;
	va_start(args, format);
	AttachConsole(ATTACH_PARENT_PROCESS);
	vprintf(format, args);
	if (detach_console) FreeConsole();
	va_end(args);
}

static void critical_err(char *format, ...)
{
	last_err = GetLastError();
	va_list args;
	va_start(args, format);
	FlashWindow(console_hwnd, FALSE);
	AttachConsole(ATTACH_PARENT_PROCESS);
	vfprintf(stderr, format, args);
	FreeConsole();
	va_end(args);
}

__declspec(noinline) static void disp_err(char *txt)
{
	last_err = GetLastError();
	fputs(txt, stderr);
}

static DWORD __stdcall derive_pass_keccak(LPVOID lpParam)
{
	return scrypt(PRF_KECCAK, password, pass_size, salt_keccak, 64, 32768, 16, 16, thread_header_key.keccak, sizeof thread_header_key.keccak);
}

static DWORD __stdcall thread_command(LPVOID lpParam)
{
	STARTUPINFO si = {sizeof si};
	PROCESS_INFORMATION pi;

	if (run_command) {
		WaitForSingleObject(pi_mount.hProcess, INFINITE);
		CreateProcess(NULL, run_command, NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);
		VirtualFree(run_command, 0, MEM_RELEASE);
	}
	FreeConsole();
	detach_console = TRUE;
	return 0;
}

static DWORD __stdcall aim_mount(LPVOID lpParam)
{
	DWORD flags = IMSCSI_DEVICE_TYPE_HD | IMSCSI_TYPE_PROXY | IMSCSI_PROXY_TYPE_SHM;

#ifdef _WIN64
	GetProcAddress(h_aimapi, "ImScsiCreateDevice")(NULL, INVALID_HANDLE_VALUE, &aim_device, NULL, &sector_size, NULL, &flags, comm_device, FALSE, NULL, FALSE);
#else
	GetProcAddress(h_aimapi, "_ImScsiCreateDevice@44")(NULL, INVALID_HANDLE_VALUE, &aim_device, NULL, &sector_size, NULL, &flags, comm_device, FALSE, NULL, FALSE);
#endif
	SetEvent(pi_mount.hProcess);
	out("SCSI device ID: %06x\n", aim_device);
	return 0;
}

static DWORD __stdcall aim_dismount(LPVOID lpParam)
{
	HANDLE h_vol, h_scsi;
	DWORD PortNumber = 0, DiskNumber;
	char path[] = "\\\\.\\A:";
	FARPROC ImScsiVolumeUsesDisk;

#ifdef _WIN64
	h_scsi = (HANDLE)GetProcAddress(h_aimapi, "ImScsiOpenScsiAdapter")(&PortNumber);
	CloseHandle((HANDLE)GetProcAddress(h_aimapi, "ImScsiOpenDiskByDeviceNumber")(aim_device, PortNumber, &DiskNumber));
	ImScsiVolumeUsesDisk = GetProcAddress(h_aimapi, "ImScsiVolumeUsesDisk");
#else
	h_scsi = (HANDLE)GetProcAddress(h_aimapi, "_ImScsiOpenScsiAdapter@4")(&PortNumber);
	CloseHandle((HANDLE)GetProcAddress(h_aimapi, "_ImScsiOpenDiskByDeviceNumber@12")(aim_device, PortNumber, &DiskNumber));
	ImScsiVolumeUsesDisk = GetProcAddress(h_aimapi, "_ImScsiVolumeUsesDisk@8");
#endif
	do
		if ((h_vol = CreateFileA(path, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_NO_BUFFERING, NULL)) != INVALID_HANDLE_VALUE) {
			if (ImScsiVolumeUsesDisk(h_vol, DiskNumber)) FlushFileBuffers(h_vol);
			CloseHandle(h_vol);
		}
	while (++path[4] <= 'Z');

#ifdef _WIN64
	GetProcAddress(h_aimapi, "ImScsiRemoveDeviceByNumber")(NULL, h_scsi, aim_device);
#else
	GetProcAddress(h_aimapi, "_ImScsiRemoveDeviceByNumber@12")(NULL, h_scsi, aim_device);
#endif

	return 0;
}

__declspec(noinline) static void raw_physical_read(void *buf, int size, __int64 offset)
{
	DWORD bytes_read;
	__int64 *overlap_read_Offset = (__int64*)&overlap_read.Offset;

	*overlap_read_Offset = offset;
	ReadFile(h, buf, size, NULL, &overlap_read);
	if (verbose >= 2) out(" ? Read: %d bytes at offset %I64d\n", size, offset);
	GetOverlappedResult(h, &overlap_read, &bytes_read, TRUE);
	if (bytes_read != size)
		fprintf(stderr, "%%Read error: %u / %d bytes at offset %I64d.\n", (unsigned int)bytes_read, size, *overlap_read_Offset);
}

__declspec(noinline) static void raw_physical_write(void *buf, int size, __int64 offset)
{
	DWORD bytes_written;
	__int64 *overlap_write_Offset = (__int64*)&overlap_write.Offset;

	GetOverlappedResult(h, &overlap_write, &bytes_written, TRUE);
	if (bytes_written != expected_write)
		fprintf(stderr, "%%Write error: %u / %d bytes at offset %I64d.\n", (unsigned int)bytes_written, expected_write, *overlap_write_Offset);
	memcpy(write_buf, buf, size);
	*overlap_write_Offset = offset;
	WriteFile(h, write_buf, size, NULL, &overlap_write);
	expected_write = size;
	if (verbose >= 2) out(" ! Write: %d bytes at offset %I64d\n", size, offset);
}

static LRESULT __stdcall WndProc(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
	HANDLE device;
	DWORD dw;
	DWORD access_list[] = {GENERIC_READ | GENERIC_WRITE, GENERIC_READ, FILE_READ_ATTRIBUTES, 0};
	int i;

	if (Msg == WM_ENDSESSION || (Msg == WM_POWERBROADCAST && wParam == PBT_APMSUSPEND && suspend_close)) {
		ResetEvent(exit_event);
		if (use_imdisk) {
			for (i = 0; i < _countof(access_list); i++)
				if ((device = (HANDLE)ImDiskOpenDeviceByMountPoint(mount_point, access_list[i])) != INVALID_HANDLE_VALUE) break;
			FlushFileBuffers(device);
			if (!DeviceIoControl(device, FSCTL_DISMOUNT_VOLUME, NULL, 0, NULL, 0, &dw, NULL) || !DeviceIoControl(device, IOCTL_STORAGE_EJECT_MEDIA, NULL, 0, NULL, 0, &dw, NULL))
				ImDiskForceRemoveDevice(device, 0);
			CloseHandle(device);
			ImDiskRemoveMountPoint(mount_point);
		} else
			aim_dismount(NULL);
		SignalObjectAndWait(exit_event, clean_ok, 2000, FALSE);
		return 0;
	} else
		return DefWindowProc(hWnd, Msg, wParam, lParam);
}

static DWORD __stdcall msg_window(LPVOID lpParam)
{
	MSG msg;
	WNDCLASSA wc = {};

	wc.lpfnWndProc = WndProc;
	wc.lpszClassName = "X";
	RegisterClassA(&wc);
	CreateWindowA("X", NULL, 0, 0, 0, 0, 0, NULL, NULL, NULL, NULL);

	for (;;) {
		GetMessage(&msg, NULL, 0, 0);
		DispatchMessage(&msg);
	}
	return 0;
}

static void init_key(unsigned char key[6][32])
{
	unsigned long c = dec_cipher;

	n_cipher = 0;
	do {
		if ((unsigned char)c == CIPHER_AES) {
			aes_init(&keys[n_cipher].aes, key[n_cipher]);
			aes_init(&keys[n_cipher + 1].aes, key[n_cipher + 1]);
		} else if ((unsigned char)c == CIPHER_SERPENT) {
			serpent_init(&keys[n_cipher].serpent, key[n_cipher]);
			serpent_init(&keys[n_cipher + 1].serpent, key[n_cipher + 1]);
		} else {
			twofish_init(&keys[n_cipher].twofish, key[n_cipher]);
			twofish_init(&keys[n_cipher + 1].twofish, key[n_cipher + 1]);
		}
		n_cipher += 2;
	} while (c >>= 8);
}

__declspec(noinline) static void build_file_name(TCHAR *name)
{
	_snwprintf(file_name, _countof(file_name) - 1, wcslen(name) < MAX_PATH ? L"%s" : L"\\\\?\\%s", name);
	file_name[_countof(file_name) - 1] = 0;
}

__declspec(noinline) static char *group_digit(unsigned long long n)
{
	int size = sprintf(global_str, "%I64u", n);

	while (size > 3) {
		size -= 3;
		memmove(global_str + size + 1, global_str + size, 24);
		global_str[size] = ' ';
	}
	return global_str;
}

__declspec(noinline) static void process_suffix(__int64 *size, TCHAR suffix)
{
	switch (suffix & ~0x20) {
		case 'T': *size <<= 10;
		case 'G': *size <<= 10;
		case 'M': *size <<= 10;
		case 'K': *size <<= 10;
	}
}

__declspec(noinline) static void format_size(__int64 size, int drive_number, __int64 offset, VOLUME_DISK_EXTENTS *vde)
{
	__int64 size_disp = size;
	char *suffix = "  KBMBGBTBPB";
	ULONG *global_str_ptr = (ULONG*)&global_str[11];
	int i;

	while (size_disp > 9999) size_disp >>= 10, suffix += 2;
	sprintf(global_str, "%6I64d %s", size_disp, suffix);

	memset(&global_str[9], ' ', 14);
	if (offset >= 0) {
		for (i = 0; i < 26; i++)
			if (vde[i].Extents[0].DiskNumber == drive_number && vde[i].Extents[0].StartingOffset.QuadPart == offset)
				*global_str_ptr = '(' + (('A' + i) << 8) + (':' << 16) + (')' << 24);
		sprintf(&global_str[17], "[%I64d - %I64d]", offset, offset + size - 1);
	} else
		sprintf(&global_str[23], "[0 - %I64d]", size - 1);
}

static void display_drives()
{
	int drive_number, max_drive = 0, partition_number, ext_number;
	size_t buf_size;
	char *dev_ptr;
	int entry_size, i;
	unsigned char *mbr;
	unsigned char partition_type;
	DISK_GEOMETRY_EX dge;
	DWORD n_bytes;
	__int64 offset, drive_size, partition_size, offset_ext;
	VOLUME_DISK_EXTENTS vde[26];

	for (i = 0; i < 26; i++) {
		sprintf(global_str, "\\\\.\\%c:", 'A' + i);
		h = CreateFileA(global_str, 0, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);
		if (!DeviceIoControl(h, IOCTL_VOLUME_GET_VOLUME_DISK_EXTENTS, NULL, 0, &vde[i], sizeof(VOLUME_DISK_EXTENTS), &n_bytes, NULL))
			vde[i].Extents[0].DiskNumber = -1;
		CloseHandle(h);
	}

	for (buf_size = 256 * 1024;; buf_size <<= 1) {
		dev_ptr = VirtualAlloc(NULL, buf_size, MEM_COMMIT | MEM_RESERVE, PAGE_READWRITE);
		mbr = (unsigned char*)dev_ptr;
		if (QueryDosDeviceA(NULL, dev_ptr, buf_size)) break;
		VirtualFree(dev_ptr, 0, MEM_RELEASE);
		if (GetLastError() != ERROR_INSUFFICIENT_BUFFER) return;
	}
	do {
		if (!memcmp(dev_ptr, "PhysicalDrive", 13)) {
			i = atoi(dev_ptr + 13);
			if (i > max_drive) max_drive = i;
		}
		dev_ptr += strlen(dev_ptr) + 1;
	} while (*dev_ptr);

	for (drive_number = 0; drive_number <= max_drive; drive_number++) {
		sprintf(global_str, "\\\\.\\PhysicalDrive%d", drive_number);
		if ((h = CreateFileA(global_str, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE) continue;
		sector_size = 512;
		drive_size = 0;
		if (DeviceIoControl(h, IOCTL_DISK_GET_DRIVE_GEOMETRY_EX, NULL, 0, &dge, sizeof dge, &n_bytes, NULL)) {
			sector_size = dge.Geometry.BytesPerSector;
			drive_size = dge.DiskSize.QuadPart;
		}
		if (sector_size > 4096) continue;
		format_size(drive_size, drive_number, -1, vde);
		printf("Drive %d:%s\n", drive_number, global_str);
		raw_physical_read(mbr, 2 * 4096, 0);
		if (mbr[0x01BE + 4] == 0xEE && !memcmp(mbr + sector_size, "EFI PART\0\0\1", 12)) {
			entry_size = *(int*)(mbr + sector_size + 84);
			raw_physical_read(mbr, 34 * sector_size, 0);
			for (partition_number = 0; partition_number < 128; partition_number++) {
				i = ((partition_number >> 2) + 2) * sector_size + (partition_number & 3) * entry_size;
				if (!(*(__int64*)(mbr + i) | *(__int64*)(mbr + i + 8))) break;
				offset = *(__int64*)(mbr + i + 32) * sector_size;
				partition_size = (*(__int64*)(mbr + i + 40) + 1) * sector_size - offset;
				format_size(partition_size, drive_number, offset, vde);
				printf(" -partition %d:%s\n", partition_number + 1, global_str);
			}
		}
		else if (*(USHORT*)(mbr + 0x01FE) == 0xAA55 && !((mbr[0x01BE] | mbr[0x01CE] | mbr[0x01DE] | mbr[0x01EE]) & 0x7F)) {
			for (partition_number = 1; partition_number <= 4; partition_number++) {
				partition_size = (__int64)(*(UINT*)(mbr + 0x01AE + partition_number * 16 + 12)) * sector_size;
				if (!partition_size) break;
				format_size(partition_size, drive_number, (__int64)(*(UINT*)(mbr + 0x01AE + partition_number * 16 + 8)) * sector_size, vde);
				printf(" -partition %d:%s\n", partition_number, global_str);
				partition_type = mbr[0x01AE + partition_number * 16 + 4];
				if (partition_type == 0x05 || partition_type == 0x0F) {
					offset_ext = offset = (__int64)(*(UINT*)(mbr + 0x01AE + partition_number * 16 + 8)) * sector_size;
					ext_number = 5;
					do {
						raw_physical_read(mbr, 4096, offset);
						partition_size = (__int64)(*(UINT*)(mbr + 0x01BE + 12)) * sector_size;
						format_size(partition_size, drive_number, offset + (__int64)(*(UINT*)(mbr + 0x01BE + 8)) * sector_size, vde);
						printf(" --partition %d:%s\n", ext_number++, global_str);
						offset = offset_ext + (__int64)(*(UINT*)(mbr + 0x01CE + 8)) * sector_size;
					} while (offset != offset_ext);
				}
			}
		}
		CloseHandle(h);
		puts("");
	}
}

static void benchmark(unsigned long cipher)
{
	HCRYPTPROV hProv;
	__int64 freq, init_time, enc_time, dec_time, test_time;
	int i, j, n_enc, n_dec;
	unsigned long cipher_list[] = {1, 2, 3, 0x0301, 0x0102, 0x0302, 0x030102};
	char cipher_str[32];

	thread_buffer = VirtualAlloc(NULL, DEF_BUFFER_SIZE, MEM_COMMIT | MEM_RESERVE, PAGE_READWRITE);
	request_size = DEF_BUFFER_SIZE;
	if (!CryptAcquireContext(&hProv, NULL, NULL, PROV_RSA_FULL, 0))
		CryptAcquireContext(&hProv, NULL, NULL, PROV_RSA_FULL, CRYPT_NEWKEYSET);
	CryptGenRandom(hProv, DEF_BUFFER_SIZE, thread_buffer);
	puts("The following tests are made in RAM in XTS mode.\n\nCIPHER\t\t       ENCRYPT\t DECRYPT   AVERAGE (MB/s)\n");
	SetPriorityClass(GetCurrentProcess(), ABOVE_NORMAL_PRIORITY_CLASS);
	QueryPerformanceFrequency((LARGE_INTEGER*)&freq);
	QueryPerformanceCounter((LARGE_INTEGER*)&init_time);
	do QueryPerformanceCounter((LARGE_INTEGER*)&enc_time); while (enc_time - init_time < freq / 20); // ensure that CPU is at correct frequency
	test_time = freq >> 1;
	for (j = 0; j < _countof(cipher_list); j++) {
		dec_cipher = cipher ? cipher : cipher_list[j];
		enc_cipher = _bswap(dec_cipher);
		do enc_cipher >>= 8; while (!(enc_cipher & 0xff));
		init_key((void*)thread_buffer);
		n_enc = n_dec = 0;
		QueryPerformanceCounter((LARGE_INTEGER*)&init_time);
		do {
			i = 0; do SetEvent(encrypt_event[i]); while (++i < sys.dwNumberOfProcessors);
			WaitForMultipleObjects(sys.dwNumberOfProcessors, crypt_done, TRUE, INFINITE);
			QueryPerformanceCounter((LARGE_INTEGER*)&enc_time);
			n_enc++;
		} while (enc_time - init_time < test_time);
		do {
			i = 0; do SetEvent(decrypt_event[i]); while (++i < sys.dwNumberOfProcessors);
			WaitForMultipleObjects(sys.dwNumberOfProcessors, crypt_done, TRUE, INFINITE);
			QueryPerformanceCounter((LARGE_INTEGER*)&dec_time);
			n_dec++;
		} while (dec_time - enc_time < test_time);
		sprintf(cipher_str, "%s%s%s%s%s", cipher_name[dec_cipher & 0xff], dec_cipher & 0xff00 ? "-" : "", cipher_name[(dec_cipher >> 8) & 0xff], dec_cipher & 0xff0000 ? "-" : "", cipher_name[dec_cipher >> 16]);
		printf("%-23s%7.0f%10.0f%10.0f\n", cipher_str,
			   (double)n_enc * (DEF_BUFFER_SIZE >> 20) * freq / (enc_time - init_time),
			   (double)n_dec * (DEF_BUFFER_SIZE >> 20) * freq / (dec_time - enc_time),
			   (double)(n_enc + n_dec) * (DEF_BUFFER_SIZE >> 20) * freq / (dec_time - init_time));
		if (cipher) break;
	}
}

int wmain(int argc, TCHAR *argv[])
{
	int drive_number = -1;
	int partition_number = 1;
	BYTE force_partition = FALSE;
	int entry_size;
	unsigned char *mbr;
	__int64 offset_ext, extra_offset = 0;
	BYTE new_volume = FALSE, change_pass = FALSE, show_pass = FALSE, pass_alternate = FALSE, use_prompt = TRUE, bench = FALSE;
	int n_hash = 0;
	__int64 current_size, new_file_size = 0;
	__int64 max_volume_size, size_new_volume = 0;
	FILE_BASIC_INFORMATION fbi;
	IO_STATUS_BLOCK iosb;
	DISK_GEOMETRY_EX dge;
	DWORD n_bytes;
	TCHAR suffix, *opt, *prompt_buf, *p1 = NULL, *p2 = NULL, *p3 = NULL;
	TCHAR *file_name_ptr = NULL, *backup_file = NULL;
	BYTE backup_file_exist = FALSE, mount = FALSE, date_ok = FALSE;
	TCHAR drive_letter[] = L" :";
	char path[MAX_PATH];
	int i, j, retval = 1;
	HEADER_STRUCT *header;
	union {unsigned char ch[512 + 64]; HEADER_STRUCT header; __m128i i128;} tmp_header;
	unsigned char *buf;
	void *header_key = thread_header_key.whirlpool;
	HANDLE h_cpl, h_backup = NULL, thread_handle = NULL;
	int CPUInfo[4];
	unsigned long imdisk_version = 0;

	if (argc < 2) {
		PathStripPath(argv[0]);
		PathRemoveExtension(argv[0]);
		i = min(wcslen(argv[0]), 21);
		memset(global_str, ' ', i);
		global_str[i] = 0;
		printf("version 1.9.4\n\n"
			"-= Syntax =-\n"
			"%S [mount_point] -f file | -d drivenumber[,[partition]] [-r]\n"
			"%s [-c [size]] [-p partition] [-o offset] [-cp] [-sp] [-pa]\n"
			"%s [-ad time] [-ads] [-t threads] [-b backup_file] [-pp ...]\n"
			"%s [-fp \"arguments\"] [-run \"exe\" \"arg\"] [-v verbose] [-aim]\n"
			"%S -l\n"
			"%S -bm [cipher[,cipher[,cipher]]] [-t threads]\n\n"
			" mount_point\n"
			"\tSpecifies a drive letter (followed by a colon) or an empty directory\n"
			"\tlocated on a NTFS volume. If omitted, a drive letter is selected\n"
			"\tautomatically.\n\n"
			" -f\tImage File of the encrypted volume.\n\n"
			" -r\tMount a volume as Read-only.\n\n"
			" -c\tCreate a new encrypted volume. If a size and a file name are specified,\n"
			"\tan image file of this size will be created. Use k, m, g or t as suffix\n"
			"\tto specify KB, MB, GB or TB.\n\n"
			" -p\tNumber of Partition (default: 1). Use 0 to ignore the partition table\n"
			"\t(if any) and to use the whole disk or image.\n\n"
			" -d\tNumber of physical Drive where the encrypted volume is located.\n"
			"\tIf a comma is added without partition number, the latter is assumed to\n"
			"\tbe 0 instead of 1.\n\n"
			" -o\tOffset to the encrypted volume inside the file/drive/partition.\n"
			"\tUse k, m, g, or t as suffix to specify KB, MB, GB or TB.\n\n"
			" -cp\tChange Password.\n\n"
			" -sp\tShow Password by default (can still be hidden with the Tab key).\n\n"
			" -pa\tUse the Password Alternate input method.\n\n"
			" -ad\tAuto-Dismount after a period of inactivity, in minutes, from 1 to 71582\n\n"
			" -ads\tAuto-Dismount when system enters a Suspended state.\n\n"
			" -t\tNumber of Threads used for decryption and encryption, from 1 to 64\n"
			"\t(the default value is the number of logical processors).\n\n"
			" -b\tIf backup_file does not exist, it will be created with the content of\n"
			"\tthe volume header, encrypted with a new salt.\n"
			"\tIf backup_file exists, the volume header will be overwritten with the\n"
			"\tfirst 512 bytes of backup_file.\n\n"
			" -pp\tParameters entered at the Prompts can be put here. Intended to\n"
			"\tsemi-automated volume creation (3 parameters in same format and order)\n"
			"\tor password change (1 parameter). -cp must be put before this switch.\n\n"
			" -fp\tFormat Parameters. \"arguments\" is a quoted string passed to the format\n"
			"\tcommand. Ignored with Arsenal Image Mounter.\n\n"
			" -run\tRun an executable after the volume is mounted. If no argument is\n"
			"\trequired, use an empty quoted string.\n\n"
			" -v\tVerbosity level, from 0 to 2 (default: 1).\n\n"
			" -aim\tForce the use of Arsenal Image Mounter, in case of the ImDisk Virtual\n"
			"\tDisk Driver, which is used by default, is also installed.\n"
			"\tIf Arsenal Image Mounter is used, mount_point is ignored.\n\n"
			" -l\tDisplay a List of current physical drives and partitions, with location\n"
			"\tof first and last bytes.\n\n"
			" -bm\tBenchmark of available ciphers.\n"
			"\tA cipher number can be specified, with 1=AES, 2=Serpent and 3=Twofish.\n"
			"\tUse 2 or 3 numbers, separated by commas, for cascaded ciphers.\n\n\n"
			"-= Password editor usage =-\n"
			" Esc:\tQuit without volume mounting.\n\n"
			" Tab:\tShow/hide password.\n\n"
			" Enter:\tUsed with an empty password, it disables low level access to the\n"
			"\tkeyboard. This improves compatibility with some Input Method Editors\n"
			"\tbut removes protection against keyloggers.\n",
			argv[0], global_str, global_str, global_str, argv[0], argv[0]);
		return 0;
	}

	GetSystemInfo(&sys);
	__cpuid(CPUInfo, 1);
	if (!(CPUInfo[3] & 0x4000000)) {
		disp_err("SSE2 instructions required.");
		return 1;
	}

	argc--;
	file_name[0] = 0;
	do {
		argv++;
		if (argv[0][0] == '-') {
			opt = argv[0] + 1;
			if (!_wcsicmp(opt, L"l")) {
				display_drives();
				return 0;
			}
			if (!_wcsicmp(opt, L"bm")) {
				bench = TRUE;
				i = j = 0;
				if (argc > 1 && swscanf(argv[1], L"%d,%d,%d", &dec_cipher, &i, &j)) {
					if (dec_cipher < 1 || dec_cipher > 3) dec_cipher = 1;
					if ((unsigned int)i > 3) i = 0;
					if ((unsigned int)j > 3) j = 0;
					dec_cipher += (i << 8) + (j << 16);
					argc--;
					argv++;
				}
				continue;
			}
			if (!_wcsicmp(opt, L"f")) {
				if (--argc <= 0) goto syntax_error;
				argv++;
				build_file_name(file_name_ptr = argv[0]);
				continue;
			}
			if (!_wcsicmp(opt, L"d")) {
				if (--argc <= 0) goto syntax_error;
				argv++;
				partition_number = 0;
				force_partition = swscanf(argv[0], L"%u%c%u", &drive_number, &suffix, &partition_number) >= 2;
				continue;
			}
			if (!_wcsicmp(opt, L"r")) {
				proxy_info.flags = IMDPROXY_FLAG_RO;
				continue;
			}
			if (!_wcsicmp(opt, L"c")) {
				new_volume = TRUE;
				if (argc > 1) {
					suffix = 0;
					if (swscanf(argv[1], L"%I64d%c", &new_file_size, &suffix)) {
						process_suffix(&new_file_size, suffix);
						if (new_file_size < 24 * 1024) {
							disp_err("New file size must be at least 24 KB.");
							return 1;
						}
						argc--;
						argv++;
					}
				}
				continue;
			}
			if (!_wcsicmp(opt, L"p")) {
				if (--argc <= 0) goto syntax_error;
				argv++;
				swscanf(argv[0], L"%u", &partition_number);
				force_partition = TRUE;
				continue;
			}
			if (!_wcsicmp(opt, L"o")) {
				if (--argc <= 0) goto syntax_error;
				argv++;
				suffix = 0;
				swscanf(argv[0], L"%I64d%c", &extra_offset, &suffix);
				process_suffix(&extra_offset, suffix);
				continue;
			}
			if (!_wcsicmp(opt, L"cp")) {
				change_pass = TRUE;
				continue;
			}
			if (!_wcsicmp(opt, L"sp")) {
				show_pass = TRUE;
				continue;
			}
			if (!_wcsicmp(opt, L"pa")) {
				pass_alternate = TRUE;
				continue;
			}
			if (!_wcsicmp(opt, L"ad")) {
				if (--argc <= 0) goto syntax_error;
				argv++;
				swscanf(argv[0], L"%u", &timeout);
				if (timeout < 1) timeout = 1;
				if (timeout > 71582) timeout = 71582;
				timeout *= 60000;
				continue;
			}
			if (!_wcsicmp(opt, L"ads")) {
				suspend_close = TRUE;
				continue;
			}
			if (!_wcsicmp(opt, L"t")) {
				if (--argc <= 0) goto syntax_error;
				argv++;
				swscanf(argv[0], L"%u", &sys.dwNumberOfProcessors);
				continue;
			}
			if (!_wcsicmp(opt, L"b")) {
				if (--argc <= 0) goto syntax_error;
				argv++;
				backup_file = argv[0];
				continue;
			}
			if (!_wcsicmp(opt, L"pp")) {
				if (argc < 2) goto syntax_error;
				use_prompt = FALSE;
				p1 = argv[1];
				argc--;
				argv++;
				if (!change_pass) {
					if (argc < 3) goto syntax_error;
					p2 = argv[1];
					p3 = argv[2];
					argc -= 2;
					argv += 2;
				}
				continue;
			}
			if (!_wcsicmp(opt, L"fp")) {
				if (--argc <= 0) goto syntax_error;
				argv++;
				format_param = argv[0];
				continue;
			}
			if (!_wcsicmp(opt, L"run")) {
				if (argc < 3) goto syntax_error;
				run_command = VirtualAlloc(NULL, 32768 * sizeof(TCHAR), MEM_COMMIT | MEM_RESERVE, PAGE_READWRITE);
				_snwprintf(run_command, 32767, L"\"%s\" %s", argv[1], argv[2]);
				argc -= 2;
				argv += 2;
				continue;
			}
			if (!_wcsicmp(opt, L"v")) {
				if (--argc <= 0) goto syntax_error;
				argv++;
				verbose = *argv[0] - '0';
				continue;
			}
			if (!_wcsicmp(opt, L"aim")) {
				force_aim = TRUE;
				continue;
			}
		}
		if (argv[0][1] == ':' && argv[0][2] == 0) {
			if (argv[0][0] < 'A' || (argv[0][0] > 'Z' && argv[0][0] < 'a') || argv[0][0] > 'z') {
syntax_error:
				disp_err("Syntax error.");
				return 1;
			}
			if (PathFileExists(argv[0]))
				fprintf(stderr, "Warning: %S already in use.\n", argv[0]);
		} else {
			i = GetFileAttributes(argv[0]);
			if (i == INVALID_FILE_ATTRIBUTES || ((i & (FILE_ATTRIBUTE_DIRECTORY | FILE_ATTRIBUTE_REPARSE_POINT)) == FILE_ATTRIBUTE_DIRECTORY && !PathIsDirectoryEmpty(argv[0]))) {
				fwprintf(stderr, L"%s is not an empty directory.\n", argv[0]);
				return 1;
			}
		}
		mount_point = argv[0];
	} while (--argc > 0);

	aes_encrypt = aes_encrypt_sw;
	aes_decrypt = aes_decrypt_sw;
	if (CPUInfo[2] & 0x2000000) {
		out("AES instructions detected.\n");
		aes_encrypt = aes_encrypt_hw;
		aes_decrypt = aes_decrypt_hw;
	}

	// Create threads
	if (sys.dwNumberOfProcessors < 1) sys.dwNumberOfProcessors = 1;
	if (sys.dwNumberOfProcessors > 64) sys.dwNumberOfProcessors = 64;
	out("Uses %u thread%s for encryption/decryption.\n", sys.dwNumberOfProcessors, sys.dwNumberOfProcessors > 1 ? "s" : "");
	i = 0; do {
		if (!(encrypt_event[i] = CreateEventA(NULL, FALSE, FALSE, NULL)) || !(decrypt_event[i] = CreateEventA(NULL, FALSE, FALSE, NULL)) || !(crypt_done[i] = CreateEventA(NULL, FALSE, FALSE, NULL))) {
			disp_err("CreateEvent() failed.");
			return last_err;
		}
		if (!CreateThread(NULL, 0, encrypt_thread, (LPVOID)(size_t)i, 0, NULL) || !CreateThread(NULL, 0, decrypt_thread, (LPVOID)(size_t)i, 0, NULL)) {
			disp_err("CreateThread() failed.");
			return last_err;
		}
	} while (++i < sys.dwNumberOfProcessors);

	if (!(overlap_read.hEvent = CreateEventA(NULL, FALSE, FALSE, NULL)) || !(overlap_write.hEvent = CreateEventA(NULL, FALSE, TRUE, NULL))) {
		disp_err("CreateEvent() failed.");
		return last_err;
	}

	if (bench) {
		benchmark(dec_cipher);
		return 0;
	}

	strcpy(path, "imdisk.exe");
	use_imdisk = PathFileExistsA(path) || PathFindOnPathA(path, NULL);
	if (!use_imdisk || force_aim) {
		if ((h_aimapi = LoadLibraryA("aimapi.dll"))) {
			use_imdisk = FALSE;
			buffer_size = AIM_BUFFER_SIZE;
		} else {
			disp_err(force_aim ? "Cannot load aimapi.dll." : "Can load neither imdisk.exe nor aimapi.dll.");
			return last_err;
		}
	}
	if (use_imdisk) {
		if (!(h_cpl = LoadLibraryA("imdisk.cpl"))) {
			disp_err("Cannot load imdisk.cpl.");
			return last_err;
		}
		ImDiskOpenDeviceByMountPoint = GetProcAddress(h_cpl, "ImDiskOpenDeviceByMountPoint");
		ImDiskForceRemoveDevice = GetProcAddress(h_cpl, "ImDiskForceRemoveDevice");
		ImDiskRemoveMountPoint = GetProcAddress(h_cpl, "ImDiskRemoveMountPoint");
		GetProcAddress(h_cpl, "ImDiskGetVersion")(&imdisk_version, NULL);
		if (imdisk_version < 0x0176) {
			disp_err("ImDisk 1.7.6 or later required.");
			return 1;
		}
		if (!mount_point) {
			if ((drive_letter[0] = _bit_scan_forward(~(GetLogicalDrives() >> 3)) + 'D') > 'Z') {
				disp_err("Cannot find free drive letter.");
				return 1;
			}
			mount_point = drive_letter;
		}
	}

	if (new_file_size) {
		if (proxy_info.flags) {
			disp_err("Cannot create file in read-only mode.");
			return 1;
		}
		if ((h = CreateFile(file_name, 0, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_FLAG_BACKUP_SEMANTICS, NULL)) != INVALID_HANDLE_VALUE) {
			CloseHandle(h);
			disp_err("Error: a file or folder of this name already exists.");
			return 1;
		}
		proxy_info.file_size = new_file_size;
	} else {
		// Opening file or drive
		if (drive_number == -1) {
			if ((h = CreateFile(file_name, proxy_info.flags ? GENERIC_READ : GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_EXISTING,
								FILE_FLAG_OVERLAPPED | FILE_FLAG_WRITE_THROUGH, NULL)) == INVALID_HANDLE_VALUE) {
				fwprintf(stderr, L"Cannot open %s.\n", file_name);
				return GetLastError();
			}
			date_ok = NtQueryInformationFile(h, &iosb, &fbi, sizeof fbi, FileBasicInformation) == STATUS_SUCCESS;
			GetFileSizeEx(h, (LARGE_INTEGER*)&proxy_info.file_size);
		} else {
			sprintf(path, "\\\\.\\PhysicalDrive%d", drive_number);
			if ((h = CreateFileA(path, proxy_info.flags ? GENERIC_READ : GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING,
								 FILE_FLAG_OVERLAPPED | FILE_FLAG_NO_BUFFERING | FILE_FLAG_WRITE_THROUGH, NULL)) == INVALID_HANDLE_VALUE) {
				fprintf(stderr, "Cannot open drive %d.\n", drive_number);
				return GetLastError();
			}
			// Getting sector size
			if (DeviceIoControl(h, IOCTL_DISK_GET_DRIVE_GEOMETRY_EX, NULL, 0, &dge, sizeof dge, &n_bytes, NULL)) {
				sector_size = dge.Geometry.BytesPerSector;
				proxy_info.file_size = dge.DiskSize.QuadPart;
			}
			if (sector_size < 512 || sector_size > 4096) {
				fprintf(stderr, "\nSector size must be at least 512-bytes and at most 4096-bytes\n(detected: %d)\n", sector_size);
				return 1;
			}
		}
	}

	if (!proxy_info.file_size)
		disp_err("Cannot determine size of image/drive.\n");
	current_size = proxy_info.file_size;

	write_buf = VirtualAlloc(NULL, buffer_size, MEM_COMMIT | MEM_RESERVE, PAGE_READWRITE);
	buf = VirtualAlloc(NULL, 4096 * 5 + DEF_BUFFER_SIZE, MEM_COMMIT | MEM_RESERVE, PAGE_READWRITE);
	header = (HEADER_STRUCT*)(buf + 4096 * 2);
	password = (TCHAR*)(buf + 4096 * 4);
	prompt_buf = (TCHAR*)(buf + 4096 * 5);
	password[2047] = show_pass;
	password[2046] = pass_alternate;

	// Getting offset to the partition
	if (!new_file_size && partition_number >= 1 && partition_number <= 128 && current_size >= 2 * sector_size) {
		mbr = VirtualAlloc(NULL, 34 * sector_size, MEM_COMMIT | MEM_RESERVE, PAGE_READWRITE);
		raw_physical_read(mbr, 2 * 4096, 0);

		if (mbr[0x01BE + 4] == 0xEE && !memcmp(mbr + sector_size, "EFI PART\0\0\1", 12)) {
			out("GPT detected\n");

			entry_size = *(int*)(mbr + sector_size + 84);
			raw_physical_read(mbr, 34 * sector_size, 0);
			i = (((partition_number - 1) >> 2) + 2) * sector_size + ((partition_number - 1) & 3) * entry_size;
			if (*(__int64*)(mbr + i) | *(__int64*)(mbr + i + 8)) {
				global_offset = *(__int64*)(mbr + i + 32) * sector_size;
				proxy_info.file_size = (*(__int64*)(mbr + i + 40) + 1) * sector_size - global_offset;
			} else if (force_partition) {
				fprintf(stderr, "Partition %i not found.\n", partition_number);
				goto clean;
			}
		}
		else {
			if (*(USHORT*)(mbr + 0x01FE) == 0xAA55 && !((mbr[0x01BE] | mbr[0x01CE] | mbr[0x01DE] | mbr[0x01EE]) & 0x7F)) {
				out("MBR detected.\n");

				if (partition_number >= 5) {
					for (i = 0x01BE; i < 0x01FE; i += 16)
						if (mbr[i + 4] == 0x05 || mbr[i + 4] == 0x0F) {
							offset_ext = global_offset = (__int64)(*(UINT*)(mbr + i + 8)) * sector_size;
							raw_physical_read(mbr, 4096, global_offset);
							for (j = 5; j < partition_number; j++) {
								global_offset = offset_ext + (__int64)(*(UINT*)(mbr + 0x01CE + 8)) * sector_size;
								if (global_offset == offset_ext) {
									fprintf(stderr, "Partition %i not found.\n", partition_number);
									goto clean;
								}
								raw_physical_read(mbr, 4096, global_offset);
							}
							global_offset += (__int64)(*(UINT*)(mbr + 0x01BE + 8)) * sector_size;
							proxy_info.file_size = (__int64)(*(UINT*)(mbr + 0x01BE + 12)) * sector_size;
							break;
						}
					if (i == 0x01FE) {
						disp_err("No extended partition found.");
						goto clean;
					}
				} else {
					global_offset = (__int64)(*(UINT*)(mbr + 0x01AE + partition_number * 16 + 8)) * sector_size;
					proxy_info.file_size = (__int64)(*(UINT*)(mbr + 0x01AE + partition_number * 16 + 12)) * sector_size;
				}

				if (proxy_info.file_size)
					out("Partition %i used.\n", partition_number);
				else {
					if (force_partition) {
						fprintf(stderr, "Partition %i not found.\n", partition_number);
						goto clean;
					} else {
						global_offset = 0;
						proxy_info.file_size = current_size;
					}
				}
			} else
				out("No MBR/GPT detected. Uses entire image.\n");
		}
		VirtualFree(mbr, 0, MEM_RELEASE);
	}

	proxy_info.req_alignment = 1;
	out("Total size: %s bytes.\n", group_digit(current_size));
	out("%s bytes used from offset ", group_digit(proxy_info.file_size));
	out("%s.\n", group_digit(global_offset));

	global_offset += extra_offset;
	if (proxy_info.file_size < 20992) {
		disp_err("Too small volume.");
		goto clean;
	}
	if (extra_offset > proxy_info.file_size - 20992) {
		disp_err("Offset to the encrypted volume too high.");
		goto clean;
	}

	if (!VirtualLock(buf, 4096 * 5) |
		!VirtualLock(keys, sizeof keys) |
		!VirtualLock(&thread_header_key, sizeof thread_header_key) |
		!VirtualLock(&tmp_header, sizeof tmp_header))
		disp_err("Warning: cannot lock data into physical memory.\n");
	lock_large_buf(write_buf, buffer_size);

	whirlpool_ini();
	keccak_ini();

	if (new_volume) {
		tmp_header.header.volume_offset = (extra_offset + 512 + 4095) & ~4095;
		max_volume_size = proxy_info.file_size - tmp_header.header.volume_offset;
		suffix = 0;
		if (use_prompt) {
			printf("\n-Enter size of the encrypted volume (20 KB - %I64u KB).\n Use k, m, g, or t as suffix.\n 0 and negative values have the maximum available as base.\n", max_volume_size >> 10);
			fgetws(p1 = prompt_buf, DEF_BUFFER_SIZE / sizeof(TCHAR), stdin);
		}
		swscanf(p1, L"%I64d%c", &size_new_volume, &suffix);
		process_suffix(&size_new_volume, suffix);
		if (size_new_volume <= 0) size_new_volume += max_volume_size;
		if (size_new_volume < 20 * 1024) size_new_volume = 20 * 1024;
		if (size_new_volume > max_volume_size) size_new_volume = max_volume_size;
		tmp_header.header.volume_size = size_new_volume;

		i = j = 0;
		if (use_prompt) {
			puts("\n-Select encryption algorithm.\n Use commas to combine up to 3 ciphers\n (e.g. 2,1 decrypts first with Serpent, then with AES)\n1: AES\n2: Serpent\n3: Twofish");
			fgetws(p2 = prompt_buf, DEF_BUFFER_SIZE / sizeof(TCHAR), stdin);
		}
		swscanf(p2, L"%d,%d,%d", &dec_cipher, &i, &j);
		if (dec_cipher < 1 || dec_cipher > 3 || (unsigned int)i > 3 || (unsigned int)j > 3) {
			printf("Unrecognized value. %s selected by default.\n", "AES");
			dec_cipher = 1;
		} else
			dec_cipher += (i << 8) + (j << 16);
		enc_cipher = _bswap(dec_cipher);
		do enc_cipher >>= 8; while (!(enc_cipher & 0xff));

		if (use_prompt) {
			puts("\n-Select password hash algorithm.\n1: Whirlpool\n2: Keccak-512");
			fgetws(p3 = prompt_buf, DEF_BUFFER_SIZE / sizeof(TCHAR), stdin);
		}
		swscanf(p3, L"%d", &n_hash);
		if (n_hash < 1 || n_hash > 2) {
			printf("Unrecognized value. %s selected by default.\n", "Whirlpool");
			n_hash = 1;
		}
		n_hash--;

		for (;;) {
			puts("\nEnter password:");
			if (password_edit(password)) goto clean;
			wcscpy((TCHAR*)buf, password);
			puts("Confirm password:");
			if (password_edit(password)) goto clean;
			if (!wcscmp(password, (TCHAR*)buf)) break;
			puts("Passwords are different. Please retry.");
		}

		if (new_file_size) {
			// Creating file
			if ((h = CreateFile(file_name, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_NEW, FILE_ATTRIBUTE_NORMAL | FILE_FLAG_OVERLAPPED | FILE_FLAG_WRITE_THROUGH, NULL)) == INVALID_HANDLE_VALUE) {
				disp_err("Error: file cannot be created.");
				goto clean_err;
			}
			date_ok = NtQueryInformationFile(h, &iosb, &fbi, sizeof fbi, FileBasicInformation) == STATUS_SUCCESS;
			SetFilePointerEx(h, (LARGE_INTEGER)new_file_size, NULL, FILE_BEGIN);
			if (!SetEndOfFile(h)) {
				disp_err("Cannot create a file of the specified size.");
				CloseHandle(h);
				DeleteFile(file_name);
				goto clean_err;
			}
			SetFilePointerEx(h, (LARGE_INTEGER)0LL, NULL, FILE_BEGIN);
		}

		out("Creating master keys...\n");
		if (rand_gen(buf, 512 + 4096, n_hash)) goto clean;
		memcpy(tmp_header.header.salt, buf, 64);
		memcpy(tmp_header.header.master_key, buf + 64, sizeof header->master_key);
		whirlpool((unsigned char*)tmp_header.header.master_key, sizeof header->master_key, tmp_header.header.hash, 1, 1);

		out("Hashing password...\n");
		if (scrypt(n_hash, password, wcslen(password) * sizeof(TCHAR), buf, 64, 32768, 16, 16, header_key, sizeof thread_header_key.whirlpool)) goto clean;
		tmp_header.header.version = 1;

		raw_physical_read(header, 2 * 4096, global_offset & ~4095);
		init_key(header_key);
		XTS_EncryptSector(enc_cipher, global_offset, tmp_header.ch + 64);
		i = global_offset % 4096;
		memcpy((char*)header + i, tmp_header.ch, 512);
		memcpy((char*)header + i + 512, buf + 512, 4095 - (i + 511) % 4096);
		raw_physical_write(header, 2 * 4096, global_offset & ~4095);
		puts("Volume created successfully.");
		XTS_DecryptSector(dec_cipher, global_offset, tmp_header.ch + 64);
	}
	else
	{
		raw_physical_read(buf, 2 * 4096, global_offset & ~4095);
		memcpy(header, buf + (global_offset & 4095), 512);

		if (backup_file) {
			build_file_name(backup_file);
			h_backup = CreateFile(file_name, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ, NULL, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
			last_err = GetLastError();
			if (h_backup == INVALID_HANDLE_VALUE) {
				fwprintf(stderr, L"Cannot open %s.\n", file_name);
				goto clean_err;
			}
			if ((backup_file_exist = last_err == ERROR_ALREADY_EXISTS))
				if (!ReadFile(h_backup, (char*)header, 512, &n_bytes, NULL) || n_bytes != 512) {
					disp_err("Error while reading backup file.");
					goto clean_err;
				}
		}

enter_password:
		dec_cipher = n_hash = 0;
		puts(change_pass ? "\nEnter current password:" : "\nEnter password:");
		if (password_edit(password)) goto clean;

		printf("Checking password...");
		pass_size = wcslen(password) * sizeof(TCHAR);
		memcpy(salt_whirlpool, header->salt, 64);
		memcpy(salt_keccak, header->salt, 64);
		if (sys.dwNumberOfProcessors > 1) thread_handle = CreateThread(NULL, 0, derive_pass_keccak, NULL, 0, NULL);
		scrypt(PRF_WHIRLPOOL, password, pass_size, salt_whirlpool, 64, 32768, 16, 16, thread_header_key.whirlpool, sizeof thread_header_key.whirlpool);
		if (sys.dwNumberOfProcessors > 1) {
			if (WaitForSingleObject(thread_handle, INFINITE) != WAIT_OBJECT_0) {
				disp_err("\nWaitForSingleObject() failed.");
				goto clean_err;
			}
			CloseHandle(thread_handle);
		}
		do {
			if (dec_cipher == 0x030303) {
				if (++n_hash > 1) {
					puts(" Error. Please retry.");
					goto enter_password;
				}
				if (sys.dwNumberOfProcessors == 1) derive_pass_keccak(NULL);
				dec_cipher = 0;
			}
			dec_cipher++;
			if ((dec_cipher & 0xff) == 4) {
				dec_cipher += 0x100 - 3;
				if ((dec_cipher & 0xff00) == 0x400) dec_cipher += 0x10000 - 0x300;
			}
			init_key(n_hash ? thread_header_key.keccak : thread_header_key.whirlpool);
			memcpy(tmp_header.ch, header, 512);
			XTS_DecryptSector(dec_cipher, global_offset, tmp_header.ch + 64);
			whirlpool((unsigned char*)tmp_header.header.master_key, sizeof header->master_key, buf, 1, 1);
		} while (memcmp(buf, tmp_header.header.hash, WHIRLPOOL_DIGESTSIZE));

		puts(" OK.");
		out("Password hashed with scrypt/%s.\nCipher is %s%s%s%s%s.\n", n_hash ? "Keccak-512" : "Whirlpool",
			cipher_name[dec_cipher & 0xff], dec_cipher & 0xff00 ? "-" : "", cipher_name[(dec_cipher >> 8) & 0xff], dec_cipher & 0xff0000 ? "-" : "", cipher_name[dec_cipher >> 16]);

		enc_cipher = _bswap(dec_cipher);
		do enc_cipher >>= 8; while (!(enc_cipher & 0xff));

		if (backup_file) {
			if (backup_file_exist) {
				memcpy((char*)buf + (global_offset & 4095), header, 512);
				raw_physical_write(buf, 2 * 4096, global_offset & ~4095);
				out("Volume header written successfully.\n");
			} else {
				out("Encrypting header with new salt...\n");
				memcpy(header, tmp_header.ch, 512);
				if (rand_gen(buf, 256, n_hash)) goto clean;
				memcpy(header->salt, buf, 64);
				if (scrypt(n_hash, password, pass_size, buf, 64, 32768, 16, 16, header_key, sizeof thread_header_key.whirlpool)) goto clean;
				init_key(header_key);
				XTS_EncryptSector(enc_cipher, global_offset, (unsigned char*)header + 64);
				if (!WriteFile(h_backup, (char*)header, 512, &n_bytes, NULL) || n_bytes != 512) {
					disp_err("Error while saving volume header.");
					goto clean_err;
				}
				out("Volume header saved successfully.\n");
			}
			CloseHandle(h_backup);
		}

		if (change_pass) {
			for (;;) {
				puts("\nEnter new password:");
				if (password_edit(password)) goto clean;
				wcscpy((TCHAR*)buf, password);
				puts("Confirm new password:");
				if (password_edit(password)) goto clean;
				if (!wcscmp(password, (TCHAR*)buf)) break;
				puts("Passwords are different. Please retry.");
			}
			if (use_prompt) {
				puts("\n-Select password hash algorithm:\n1: Whirlpool\n2: Keccak-512");
				fgetws(p1 = prompt_buf, DEF_BUFFER_SIZE / sizeof(TCHAR) - 2 * 4096, stdin);
			}
			swscanf(p1, L"%d", &n_hash);
			if (n_hash < 1 || n_hash > 2) {
				printf("Unrecognized input. %s selected by default.\n", "Whirlpool");
				n_hash = 1;
			}
			n_hash--;
			out("Hashing new password...\n");
			if (rand_gen(buf, 256, n_hash)) goto clean;
			memcpy(tmp_header.header.salt, buf, 64);
			if (scrypt(n_hash, password, wcslen(password) * sizeof(TCHAR), buf, 64, 32768, 16, 16, header_key, sizeof thread_header_key.whirlpool)) goto clean;
			init_key(header_key);
			XTS_EncryptSector(enc_cipher, global_offset, tmp_header.ch + 64);
			raw_physical_read(header, 2 * 4096, global_offset & ~4095);
			memcpy((char*)header + global_offset % 4096, tmp_header.ch, 512);
			raw_physical_write(header, 2 * 4096, global_offset & ~4095);
			puts("Password changed.");
			XTS_DecryptSector(dec_cipher, global_offset, tmp_header.ch + 64);
		}
	}

	init_key(tmp_header.header.master_key);
	global_offset += tmp_header.header.volume_offset - extra_offset;
	proxy_info.file_size = tmp_header.header.volume_size;
	out("Encrypted volume of %s bytes at offset ", group_digit(proxy_info.file_size));
	out("%s.\n\n", group_digit(global_offset));
	mount = TRUE;
	goto clean;

clean_err:
	retval = last_err;

clean:
	SecureZeroMemory(buf, 4096 * 5);
	VirtualFree(buf, 0, MEM_RELEASE);
	SecureZeroMemory(&thread_header_key, sizeof thread_header_key);
	SecureZeroMemory(&tmp_header, sizeof tmp_header);
	pass_size = 0;

	exit_event = CreateEventA(NULL, FALSE, TRUE, NULL);
	clean_ok = CreateEventA(NULL, FALSE, FALSE, NULL);
	if (mount) {
		console_hwnd = GetConsoleWindow();
		SetProcessShutdownParameters(0x100, 0);
		CreateThread(NULL, 0, msg_window, NULL, 0, NULL);
		retval = do_comm();
	}

	SecureZeroMemory(keys, sizeof keys);
	CloseHandle(h);
	if (date_ok) {
		build_file_name(file_name_ptr);
		h = CreateFile(file_name, FILE_WRITE_ATTRIBUTES, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_FLAG_WRITE_THROUGH, NULL);
		NtSetInformationFile(h, &iosb, &fbi, sizeof fbi, FileBasicInformation);
		CloseHandle(h);
	}
	SignalObjectAndWait(clean_ok, exit_event, 5000, FALSE);

	return retval;
}

#ifdef MINGW_NOSTDLIB
void mainCRTStartup()
{
	int argc;
	LPWSTR *argv = CommandLineToArgvW(GetCommandLine(), &argc);
	ExitProcess(wmain(argc, argv));
}
#endif
